﻿:namespace Setup ⍝ V1.06
⍝ Script for Personalization of Spice
⍝ 2015 05 21 Adam: NS header
⍝ 2015 06 01 Adam: Total Help overhaul and auto PW
⍝ 2015 11 12 Adam: moved help layout to framework
⍝ 2015 12 01 DanB: account for Mac OS and allow 2 locations for setup

    ⎕ML←1 ⋄ ⎕IO←1 ⋄ Folder←'MyUCMDs'
    DESC←'Setup personalization of user environment'

    ∇ r←Path;ost
      ost←'Win' 'Mac'⍳⊂3↑1⊃# ⎕WG'aplversion'
      r←(ost⊃'C:\Users\' '/Users/' '/home/'),⎕AN,ost⊃'\Documents\' '/' '/'
    ∇

    rtb←{(-⊥⍨' '=⍵)↓⍵}

    ∇ r←List
      r←⎕NS''
      r.Name←'USetup'
      r.(Group Parse)←'UCMD' ''
      r.Desc←DESC
      r←,r
    ∇

    ∇ r←Run(Cmd arg);ns;file;fn;path;exist
      r←0 0⍴''
    ⍝ Run user setup
      path←Path
      exist←{22::0 ⋄ 1⊣⎕NUNTIE ⍵ ⎕NTIE 0}
      :Trap 2 ⋄ exist←⎕NEXISTS ⋄ :EndTrap
      :If exist file←path,Folder,'/setup.dyalog' ⍝ avoid setting ⎕DMX
      :OrIf exist file←path,'.dyalog/',Folder,'/setup.dyalog'
          ns←fn←⎕SE.SALT.Load file,' -noname'
          :If 2=⎕NC'ns'
              ns←⎕NS'' ⋄ ns.⎕FX fn
          :EndIf
          ns.{85:: ⋄ x←'Setup',(0≠1 2⊃⎕AT'Setup')/' ⍵' ⋄ 2::1(85⌶)x ⋄ 85⌶x}arg
      :EndIf
    ∇

    ∇ r←level Help Cmd;h
      r←⊂DESC
      :If 0=level
          r,←⊂']??',Cmd,' ⍝ for more info'
      :Else
          h←⊢'This command is used to initialize a user''s setup. '
          h,←'It is called automatically when the user command system is started.'
          r,←''h''
          h←⊢'To use it, save a function named "Setup" (or namespace with such a function) as "'
          h,←Path,Folder,'/setup.dyalog". This function will be called with ''init'' as argument.'
          r,←h''
          r,←⊢'Example:' '    To always let F2 list variables and F3 list functions:'
          r,←⊂'        Setup←{('')VARS'',⊂''ER'') ('')FNS'',⊂''ER'') ⎕PFKEY¨2 3}'
          r,←⊂'        ]Save Setup ',Path,Folder,'/setup.dyalog'
      :EndIf
    ∇

    ∇ setupKeys arg;sp
    ⍝ arg is a char vector possibly embedded with or followed by an enclosed string, eg: 'dothis',⊂'ER'
      :If ''≡arg
          sp←{d←326=⎕DR ¯1↑v←,⍵ ⋄ v[b/⍳⍴b←'"'≡¨v]←'''' ⋄ ⍺,(v,d↓⊂'ER')⎕PFKEY ⍺}
         ⍝ e.g. 13 sp'"." ⎕wg "aplversion"'
          2 sp'⎕se.SALTUtils.EditorFix "chk"'
      :EndIf
    ∇

:Endnamespace ⍝ Setup  $Revision: 26774 $