﻿:namespace Summary ⍝ V1.07
⍝ Misc utils
⍝ 2015 05 28 Adam: toHex & FromHex & Factors & PivotTable moved Tools → Calc
⍝ 2015 11 12 DanB: changed summary header
⍝ 2016 02 12 DanB: modified CD to work under *nix

    ⎕ml←3 ⋄ ⎕io←1 ⋄ V14←14≤Ver←{⍎⍵↑⍨⍵⍳'.'}2⊃'.' ⎕wg'aplversion'
    AllCmds←'Summary' 'Calls' 'Xref'  'CD'  'Display' 'Disp' 'toHex' 'fromHex' 'Factors' 'toQuadTS',V14/⊂'PivotTable'

    ∇ r←List;i
      r←⎕NS¨(⍴AllCmds)⍴⊂''
      r.Group←'NS' 'FN' 'NS' 'File' 'Output' 'Output' 'Calc' 'Calc' 'Calc' 'File',V14/⊂'Calc'
      r.Parse←'1L -file' '1-2L -details -treeview -file -full -isolate[=]' '1L -file=' '1S' '' '' '' '1L' '1' '',V14/⊂'1L -f:≢'
      r.Name←AllCmds
      i←0 ⍝ i←i+1 allows inserting new cmds w/o renumbering
      r[i←i+1].Desc←'Returns a summary of the objects in a namespace or scriptfile'
      r[i←i+1].Desc←'Returns the calling tree of a function in a namespace or scriptfile'
      r[i←i+1].Desc←'Returns a Cross-reference of the objects in a namespace or scriptfile'
      r[i←i+1].Desc←'Change (Windows only) or report the current working directory'
      r[i←i+1].Desc←'DISPLAY expression'
      r[i←i+1].Desc←'disp expression'
      r[i←i+1].Desc←'Show hexadecimal representation of 32 bits integer(s)'
      r[i←i+1].Desc←'Show decimal representation of hexadecimal number(s)'
      r[i←i+1].Desc←'Show the prime factors of a number'
      r[i←i+1].Desc←'Show the ⎕TS equivalent of a component timestamp'
      →V14↓0
      r[i←i+1].Desc←'Create a Pivot Table from data'
    ∇

    ∇ r←Run(Cmd Args);ct;ns;sw;sp;file;arg;tmpNS;fn;nsname;Cn;b;ok;⎕PP
    ⍝ Execute cmd for all the defined commands
     
      :If 4>Cn←AllCmds⍳⊂Cmd
          fn←file←1⊃ct←Args.Arguments
          :If ok←Cn=2 ⍝ Cmd≡'FnCalls'
              :If ok←1=⍴ct
                  :If ok←∧/b←'.'≠file
                      file←'⎕this'
                  :Else
                      file↓⍨←-1+⍴fn←(-⊥⍨b)↑file ⍝ accept ns.fn
                  :EndIf
              :Else ⋄ file←2⊃ct
              :EndIf
          :EndIf
          :If ~Args.file         ⍝ get the space
              'Only for [name]spaces'⎕SIGNAL 11/⍨ok<9≠##.THIS.⎕NC file
              tmpNS←##.THIS⍎file
          :Else
              r ⎕SIGNAL 11↓⍨0∊⍴⍴r←tmpNS←⎕SE.SALT.Load'"',file,'" -noname'
          :EndIf
          ct←⎕SE.SALT.New'tools\code\callingTree'tmpNS
      :EndIf
     
      :Select Cn
      :Case 1⊣'Summary'
          r←format ct.FnRefs
      :Case 2⊣'FnCalls'
          :If 0≢nsname←Args.isolate
              'Namespace name must be free'⎕SIGNAL 11↓⍨(0=##.THIS.⎕NC⍕nsname)∨nsname≡1
              'Isolate only works on namespaces or #'⎕SIGNAL 11↓⍨(9.1=⎕NC⊂'tmpNS')∨#≡tmpNS
              r←ct.Calls fn,' -raw'               ⍝ get raw info to gather globals and fns
              sp←⊃,/(∊∘'G'¨1⊃¨r[;3])/¨2⊃¨r[;3]    ⍝ this should work even with a 0 line niladic fn
              sp←∪(∧\¨'.'≠sp)/¨sp                 ⍝ only namespace kept in ns.x
              sp←(0<tmpNS.⎕NC sp)⌿sp              ⍝ ignore ⎕names
              sp←⊃r[;1],sp
              r←tmpNS.⎕NS sp                      ⍝ create a ns from the objects
              :If nsname≢1
                  r←0 0⍴''{⍺}nsname ##.THIS.⎕NS r ⍝ create a separate ns with all the objects
              :Else
                  r←##.THIS.⎕NS r
              :EndIf
          :Else
              r←ct.Calls(⊂fn),Args.(treeview details 999 full)
          :EndIf
      :Case 3⊣'Xref'
          r←ct.Xref
          :If 0≢file←Args.file
              r ⎕SE.SALTUtils.PutUTF8File file
              r←'Result in file ',file
          :EndIf
      :Case 4⊣'cd'
          r←CD{(+/∧\' '=⍵)↓⍵}1⊃Args.Arguments,⊂''
      :Case 5⊣'display'
          →0↓⍨' '∨.≠r←Args
          r←display ##.THIS⍎r
      :Case 6⊣'disp'
          →0↓⍨' '∨.≠r←Args
          r←1 1 0 1 disp ##.THIS⍎r
      :Case 7⊣'toHex'
          →0↓⍨' '∨.≠r←Args
          r←1 hex ##.THIS⍎r⊣⎕PP←34
      :Case 8⊣'fromHex'
          r←0 hex 1⊃Args.Arguments
      :Case 9⊣'factorsof'
          r←factorsOf ##.THIS⍎1⊃Args.Arguments
      :Case 10⊣'to⎕ts'
          →0↓⍨' '∨.≠r←Args
          r←dywftt ##.THIS⍎r
      :Case 11 ⍝ pivot table
          r←(##.THIS⍎Args.f)pivot ##.THIS⍎1⊃Args.Arguments
      :EndSelect
    ∇

    ∇ r←a cat1 b;sa;sb
      sa←(⍴a)⌈0 1×sb←⍴b
      r←(sa↑a)⍪(sb⌈0 1×sa)↑b
    ∇

    ∇ r←tox hex num;HEX;⎕IO;⎕ML;b
     ⍝ Turn a 32 bit integer into HEX format or the other way around if la is 0
      →(num∨.≠' ')↓⍴r←⍬
      ⎕ML←⎕IO←0 ⋄ HEX←⎕D,'ABCDEFabcdef'
      num←b\num/⍨b←~num∊',' ⍝ tolerant of ,
      :If tox∧∨/0 2∊10|⎕DR num ⋄ num←1⊃⎕VFI num ⋄ :EndIf ⍝ accept char string
      :If tox
          'must be 32 bits signed integer'⎕SIGNAL 11/⍨323<⎕DR num
          r←{HEX[{(1⌈⍴⍵)↑⍵},16⊥⍣¯1⊢(323⌊⎕DR ⍵)⎕DR ⍵]}¨num
      :Else
          num←'(?<!\d)0x'⎕R''⊢num ⍝ remove any 0x before the numbers
          'invalid number(s)'⎕SIGNAL 11↓⍨∧/num∊' ',HEX
          num←(⊂'')~⍨{1↓¨(⍵∊' ')⊂⍵}' ',num ⍝ cut on spaces
          r←16⊥¨{⍵-6×⍵>15}¨HEX∘⍳¨num
      :EndIf
    ∇

      display←{⎕IO ⎕ML←0                              ⍝ Boxed display of array.
          ⍺←1 ⋄ chars←⍺⊃'..''''|-' '┌┐└┘│─'           ⍝ ⍺: 0-clunky, 1-smooth.
          tl tr bl br vt hz←chars                     ⍝ Top left, top right, ...
          box←{                                       ⍝ Box with type and axes.
              vrt hrz←(¯1+⍴⍵)⍴¨vt hz                  ⍝ Vert. and horiz. lines.
              top←(hz,'⊖→')[¯1↑⍺],hrz                 ⍝ Upper border with axis.
              bot←(⊃⍺),hrz                            ⍝ Lower border with type.
              rgt←tr,vt,vrt,br                        ⍝ Right side with corners.
              lax←(vt,'⌽↓')[¯1↓1↓⍺],¨⊂vrt             ⍝ Left side(s) with axes,
              lft←⍉tl,(↑lax),bl                       ⍝ ... and corners.
              lft,(top⍪⍵⍪bot),rgt                     ⍝ Fully boxed array.
          }
          deco←{⍺←type open ⍵ ⋄ ⍺,axes ⍵}             ⍝ Type and axes vector.
          axes←{(-2⌈⍴⍴⍵)↑1+×⍴⍵}                       ⍝ Array axis types.
          open←{(1⌈⍴⍵)⍴⍵}                             ⍝ Expose null axes.
          trim←{(~1 1⍷∧⌿⍵=' ')/⍵}                     ⍝ Remove extra blank cols.
          type←{{(1=⍴⍵)⊃'+'⍵}∪,char¨⍵}                ⍝ Simple array type.
          char←{⍬≡⍴⍵:hz ⋄ (⊃⍵∊'¯',⎕D)⊃'#~'}∘⍕         ⍝ Simple scalar type.
          {                                           ⍝ Recursively box arrays:
              0=≡⍵:' '⍪(open ⎕FMT ⍵)⍪(⊃⍵ ⍵∊⎕AV)⊃' -'  ⍝ Simple scalar.
              1 ⍬≡(≡⍵)(⍴⍵):'∇' 0 0 box ⎕FMT ⍵         ⍝ Object rep: ⎕OR.
              1=≡⍵:(deco ⍵)box open ⎕FMT open ⍵       ⍝ Simple array.
              ('∊'deco ⍵)box trim ⎕FMT ∇¨open ⍵       ⍝ Nested array.
          }⍵
      }
      disp←{⎕IO ⎕ML←0                             ⍝ Boxed sketch of nested array.
     
          ⍺←⍬ ⋄ opt ldr ctd←3↑⍺,3/1               ⍝ ⍺: decorated, box_chars, centred.
     
          ul uc ur←ldr⊃⌽'┌┬┐' '.'                 ⍝ upper──┐ ┌───left
          ml mc mr←ldr⊃⌽'├┼┤' '|+|'               ⍝ middle─┼×┼─centre
          ll lc lr←ldr⊃⌽'└┴┘' ''''                ⍝ lower──┘ └──right
          vt hz←ldr⊃'|-' '│─'                     ⍝ vertical and horizontal.
     
          box←{                                   ⍝ Recursively box nested array.
              isor ⍵:⎕FMT⊂⍵                       ⍝ ⎕or: '∇name'.
              1≥|≡⍵:open ⎕FMT open ⍵              ⍝ simple array: format.
              subs←expand ∇¨matr open ⍵           ⍝ expanded boxed sub-arrays.
              odec←(shape ⍵)outer subs            ⍝ outer type and shape decoration.
              idec←inner ⍵                        ⍝ inner type and shape decorations.
              (odec,idec)collect subs             ⍝ collected, formatted sub-arrays.
          }
     
          expand←{                                ⍝ Align and centre sub-arrays.
              rows cols←sepr⍴¨⍵                   ⍝ sub-array dimensions.
              sizes←(⌈/rows)∘.,⌈⌿cols             ⍝ expanded sub-array sizes.
              ctd=0:sizes↑¨⍵                      ⍝ top-left alignment.
              v h←sepr⌈0.5×↑(⍴¨⍵)-sizes           ⍝ vertical and horizontal rotation.
              v⊖¨h⌽¨sizes↑¨⍵                      ⍝ centred expanded sub-arrays.
          }
     
          outer←{                                 ⍝ Outer decoration.
              on←{⍺:⍺⍺ ⍵ ⋄ ⍵}                     ⍝ conditional function application.
              sizes←1 0{⊃↓⍺⍉on ⍵}¨sepr⍴¨⍵         ⍝ row and col sizes of sub-arrays.
              sides←sizes/¨¨vt hz                 ⍝ vert and horiz cell sides.
              bords←1↓¨ml uc glue¨sides           ⍝ joined up outer borders.
              ↑,¨/(ul'')⍺ bords(ll ur)            ⍝ vertical and horizontal borders.
          }
     
          inner←{                                 ⍝ Inner sub-array decorations.
              deco←{(type ⍵),shape ⍵}             ⍝ type and shape decorators.
              sepr deco¨matr open ⍵               ⍝ decorators: tt vv hh .
          }
     
          collect←{                               ⍝ Collect sub-arrays.
              lft top tt vv hh←⍺                  ⍝ array and sub-array decorations.
              boxes←vv right(tt hh)lower ⍵        ⍝ cells boxed right and below.
              lft,top⍪↑⍪⌿,/open boxes             ⍝ completed collection.
          }
     
          lower←{                                 ⍝ Border below each sub-array.
              bot←{⍵⍪(-1⊃⍴⍵)↑⍺ split ⍵}           ⍝ lower border.
              split←{((¯2+1⊃⍴⍵)/hz)glue ⍺}        ⍝ decorators split with horiz line.
              (matr↑,¨/⍺)bot¨matr ⍵               ⍝ cells bordered below.
          }
     
          right←{                                 ⍝ Border right each sub-array.
              types←2⊥¨(⍳⍴⍵)=⊂¯1+⍴⍵               ⍝ right border lower corner types.
              chars←mc mr lc lr[types]            ⍝    ..     ..      ..      chars.
              rgt←{⍵,(¯2+⊃⍴⍵)1 1/vt,⍺}            ⍝ form right border.
              ((matr ⍺),¨chars)rgt¨⍵              ⍝ cells bordered right.
          }
     
          type←{                                  ⍝ Type decoration char.
              opt<|≡⍵:hz                          ⍝ nested: '─'
              isor ⍵:'∇'                          ⍝ ⎕or:    '∇'
              sst←{                               ⍝ simple scalar type.
                  0=opt×⍴⍴⍵:hz                    ⍝ undecorated or scalar ⍕⍵: char,
                  (⊃⍵∊'¯',⎕D)⊃'#~'                ⍝ otherwise, number or space ref.
              }∘⍕                                 ⍝ ⍕ distinguishes type of scalar.
              0=≡⍵:sst ⍵                          ⍝ simple scalar: type.
              {(1=⍴⍵)⊃'+'⍵}∪,sst¨open ⍵           ⍝ array: mixed or uniform type.
          }
     
          shape←{                                 ⍝ Row and column shape decorators.
              0=opt×⍴⍴⍵:vt hz                     ⍝ scalar or no decoration.
              cols←(×¯1↑⍴⍵)⊃'⊖→'                  ⍝ zero or more cols.
              rsig←(××/¯1↓⍴⍵)⊃'⌽↓'                ⍝ zero or more rows.
              rows←(¯1+3⌊⍴⍴⍵)⊃vt rsig'⍒'          ⍝ high rank decorator overrides.
              rows cols                           ⍝ shape decorators.
          }
     
          matr←{↑,↓⍵}                             ⍝ Matrix from non-scalar array.
          sepr←{+/¨1⊂↑⍵}                          ⍝ Vec-of-mats from mat-of-vecs.
          open←{16::(1⌈⍴⍵)⍴⊂'[ref]' ⋄ (1⌈⍴⍵)⍴⍵}   ⍝ Stretch to expose nulls.
          isor←{1 ⍬≡(≡⍵)(⍴⍵)}                     ⍝ Is ⎕or of object?
          glue←{↑⍺{⍺,⍺⍺,⍵}/⍵}                     ⍝ Intersperse ⍵ with ⍺s.
     
          box ⍵                                   ⍝ recursively box array.
      }

    ∇ {old}←CD new;os;is64;t;get;lib;chdir;⎕ML                    ⍝ Change or report directory
    ⍝ Change Directory under the OS
      ⎕ML←1
      os←3↑1⊃'.'⎕WG'APLversion'
      :If os≡'Win'                 ⍝ Under Windows we do the association here because we need
          t←'A*'[1+80=⎕DR'']       ⍝ the programs to GET the current directory
          'get'⎕NA'U Kernel32|GetCurrentDirectory',t,' U >0T' ⍝ Associate Get function
          old←2⊃get 260 260                                   ⍝ in all cases we return the current dir
          'chdir'⎕NA'U Kernel32|SetCurrentDirectory',t,' <0T' ⍝ Associate Set function
      :Else
          old←⊃⎕SH'pwd'
      :EndIf
     
      :If ~0∊⍴new         ⍝ change directory
          :If os≡'Win'
             ⍝ chdir returns a single int: 1=ok
              'Unable to change directory'⎕SIGNAL(chdir⊂new)↓11
          :Else
              :Select os
              :Case 'AIX'
                  is64←32={z←⍵ ⋄ ⎕SIZE'z'}⍬
                  lib←'I libc.a(shr',(is64/'_64'),'.o)|chdir <0T1[]'
              :Case 'Lin'
             ⍝ Extract real name of libc that we are actually using
                  t←⊃⎕SH'echo $PPID'
                  t←⎕SH'ldd /proc/',t,'/exe'
                  lib←⊃('^\s*libc\.so\b.*=>\s*(\S*)'⎕S'\1')t
                  lib←'I ',lib,'|chdir <0T1[]'
              :Case 'Mac'
                  lib←'I /usr/lib/libc.dylib|chdir <0T1[]'
                  ⍝ chdir returns a single integer: 0=ok
              :EndSelect
              ⎕NA lib
              'Unable to change directory'⎕SIGNAL(0≠chdir⊂new)/11
          :EndIf
      :EndIf
    ∇


      factorsOf←{⎕ML ⎕IO←1        ⍝ Prime factors of ⍵.
          ⍵{                      ⍝ note: ⎕wa>(⍵*÷2)×2*4.
              ⍵,(⍺÷×/⍵)~1         ⍝ append factor > sqrt(⍵).
          }∊⍵{                    ⍝ concatenated,
              (0=(⍵*⍳⌊⍵⍟⍺)|⍺)/⍵   ⍝ powers of each prime factor.
          }¨⍬{                    ⍝ remove multiples:
              nxt←⊃⍵              ⍝ next prime, and
              msk←0≠nxt|⍵         ⍝ ... mask of non-multiples.
              ∧/1↓msk:⍺,⍵         ⍝ all non multiples - finished.
              (⍺,nxt)∇ msk/⍵      ⍝ sieve remainder.
          }⍵{                     ⍝ from,
              (0=⍵|⍺)/⍵           ⍝ divisors of ⍵ in:
          }2,(1+2×⍳⌊0.5×⍵*÷2),⍵   ⍝ 2,3 5 .. sqrt(⍵),⍵
      }

⍝ Produce a summary of a class' (in a .Dyalog file) objects.

    ∇ r←format m3c;ss;t3
    ⍝ Format function references
    ⍝ 3rd column contains scope, size & syntax as per ⎕AT
      r←'No functions found' ⋄ →0/⍨0∊⍴m3c
      t3←⊃,0 1↓ss←0 1↓⊃m3c[;3] ⋄ ss[;2]←t3[;1] ⋄ t3←↓1+|0 1↓t3
      t3←t3⌷¨⊂⊃∘.,/'nr' '012' 'fmd'
      r←⍕'Name' 'Scope' 'Size' 'Syntax'⍪m3c[;1],ss,t3
    ∇

    ∇ ts←dywftt ts;md;shape;tmp;yr;z;⎕IO
    ⍝ *** convert ⎕FRDCI timestamp(s) to ⎕ts-format for Dyalog/W ***
    ⍝ right argument: ⎕FRDCI-type timestamp(s) of any shape
    ⍝ result: ⎕ts-type timestamp(s) with shape <(⍴argument),7>
    ⍝ Only works through 2099!
      ⎕IO←0 ⋄ shape←⍴ts ⋄ ts←,ts+18626112000
      md←365.2501|1+1461|yr←⌊ts÷5184000
      tmp←31 61 92 122 153 184 214 245 275 306 337 366
      z←(,⍉<⍀tmp∘.≥md)/,((⍴md),12)⍴⍳12
      md←(1+12|z+2),[0.1]⌈md-(0,tmp)[z]
      ts←(1960+⌊(yr+60)÷365.25),md,⍉24 60 60 60⊤ts
      ts[;6]←⌊0.5+ts[;6]×100÷6
      ts←(shape,7)⍴ts
    ∇

    ∇ table←(F pivot)data;all;Z;rc;⎕IO;d;t;K;there;keys;unik
⍝ Excel Pivot Table emulator
⍝ data is a 2 or 3 column matrix whose last column contains numbers
⍝ We could generate tables with more dimensions, this version is restricted to 2
      ⎕IO←0 ⋄ K←{⍺,F ⍵}⌸
      :If 2∊1↓⍴data ⍝ 2 column case
          table←{⍵⍪'Total'(+/,0 1↓⍵)}data[;0]K data[;1]
      :Else         ⍝ assume 3 columns
    ⍝ We generate a 2D table of all the combinations of data[;⍳2]
          rc←↑,/⍴¨unik←∪¨↓⍉keys←0 ¯1↓data
          Z←{0}¨all←,↑∘.,/unik ⋄ there←,/keys
          (t d)←↓⍉there K,data[;¯1+¯1↑⍴data]
          Z[all⍳t]←d ⋄ t←⊂'Total'
         ⍝ This only works for 3 col data
          table←(' ',(0⊃unik),t),((1⊃unik),t)⍪d⍪+⌿d←d,+/d←rc⍴Z
      :EndIf
    ∇

    ∇ r←lev Help Cmd;i;F
      :Access Shared Public
      F←'' 'The switch  -file  will interpret the argument to be a filename'
      :Select AllCmds⍳⊂Cmd
      :Case 1 ⍝ Summary
          i←,⊂r←'Arg: scriptfile; Produces a short description of the functions in a class'  ⍝ summary
          →lev↓0
          i,←'' 'For a given class all regular fns & dfns are reported,'
          i,←⊂'listing their syntax and scope.'
          i,←⊂'Syntax is [nr][012][mdf] where'
          i,←⊂'n is no result, r is result'
          i,←⊂'0 is niladic, 1 monadic and 2 dyadic,'
          i,←⊂'m is a Monadic operator, d a Dyadic op and f a Function'
          i,←'' 'Example:' '   ]summary ⎕se.Parser' '' ' r0f is a result returning niladic fn'
          i,←⊂'Scope is [SPCD] where'
          i,←⊂'S is shared, P is public, C is constructor and D is destructor'
          r←⊃i,F
      :Case 2     ⍝ fncalls
          i←⊂r←'Arg: pgmname namespace ; Produces the calling tree of a program (arg 1) in a class (arg 2, default current namespace)'
          →lev↓0
          i,←F
          i,←'Example:' '   ]calls  Parse  ⎕se.Parser'
          i,←⊂'-details shows other references (ex: vars)'
          i,←' Each name is preceded by a symbol. Its meaning is' ''
          i,←⊂'  G global object (not a visible function)'
          i,←⊂'  F visible function'
          i,←⊂'  R recursive function call'
          i,←⊂'  * function already shown (only without FULL option)'
          i,←⊂'  ○ local  object'
          i,←⊂'  ! unreferenced local object'
          i,←⊂'  L referenced label'
          i,←⊂'  l unreferenced label'
          i,←⊂'  ↑ global local (global localized at an upper level)'
          i,←⊂''
          i,←⊂'-treeview uses GUI to show the result'
          i,←⊂'-full repeats description of already shown fns'
          i,←'' 'NOTE: object names reported in other namespaces are shown as Globals.'
          i,←'' '-isolate will return the objects used to run the function in a namespace'
          i,←⊂'you can thereafter assign a name or ask ]calls to do it for you by.'
          i,←'' 'Example:' '   ]calls ⎕se.SALTUtils.Spice -isolate=Curry'
          i,←''
          r←⊃i
     
      :Case 3
          i←⊂r←'Arg: namespace name; Produces a cross-reference of all objects in a class'  ⍝ xref
          →lev↓0
          i,←'Example:' '   ]xref ⎕se.Parser'
          i,←F
          r←⊃i
     
      :Case 4
          i←⊂r←'Arg: new directory. Changes the current directory to the one specified or display the current if none supplied' ⍝ cd                                                                      ⍝ cd
          →lev↓0
          i,←'Example:'('   ]cd ','\'/⍨↑'Windows'⍷↑'.'⎕WG'APLVersion')
          r←⊃i
     
      :Case 5
          i←⊂r←'Arg: any array. Shows the array as per DISPLAY'      ⍝ display
          →lev↓0
          i,←'Example:' '   ]display ⍳3 4'
          r←⊃i
     
      :Case 6
          i←⊂r←'Arg: any array. Shows the array as per the <disp> fn' ⍝ disp
          →lev↓0
          i,←'Example:' '   ]disp ⍳3 4'
          r←⊃i
     
      :Case 7
          i←⊂r←'Arg: numbers in decimal. Shows their HEX equivalent' ⍝ tohex
          →lev↓0
          i,←'Example:' '   ]tohex  61166 100 999' '' 'Related command: fromhex'
          r←⊃i
     
      :Case 8
          i←⊂r←'Arg: numbers in HEX. Shows their decimal equivalent' ⍝ fromhex
          →lev↓0
          i,←'Example:' '   ]fromhex  307 EEEE A' '' 'Related command: tohex'
          r←⊃i
     
      :Case 9
          i←⊂r←'Arg: a single integer. Its factors are returned'     ⍝ factorsof
          →lev↓0
          i,←'Example:' '   ]factors 67890'
          r←⊃i
     
      :Case 10
          i←⊂r←'Arg: a single float number. Its ⎕TS equivalent is returned'     ⍝ ftttots
          →lev↓0
          i,←'Example:' '   ]toquadts  1.23456E10' '1976 7 9 11 33 20 0'
          r←⊃i
     
      :Case 11
          r←⊃i←'Arg: a 2 or 3 col matrix. The last column must contain data' 'appropriate for the function to apply (default count).'  ⍝ pivottable
          →lev↓0
          i,←'Example:' '      m←10 2⍴J 1 J 2 A 3 J 4 I 5 J 6 J 7 I 8 I 9 J 10⊣A I J←''AIJ'''
          i,←⊂'      ]pivottable m  -f=+/'
          i,←⊂' J      30'
          i,←⊂' A       3'
          i,←⊂' I      22'
          i,←⊂' Total  55'
     
          i,←'' '   M← (20 2⍴''C3C3C4B4C2B2D1C4A4C1B3B1C1B2A0A1D1B0C1C4''),4 3 4 8 3 3 9 6 5 9 2 7 7 1 6 5 4 7 6 9'
          i,←⊂'   ]pivottable M ⍝ count the number of each by default'
          i,←⊂'        3 4 2 1 0  Total'
          i,←⊂' C      2 3 1 3 0      9'
          i,←⊂' B      1 1 2 1 1      6'
          i,←⊂' D      0 0 0 2 0      2'
          i,←⊂' A      0 1 0 1 1      3'
          i,←⊂' Total  3 5 3 7 2     20'
     
          i,←'' 'Sum each:' '   ]pivottable M  -f=+/'
          i,←⊂'        3  4 2  1  0  Total'
          i,←⊂' C      7 19 3 22  0     51'
          i,←⊂' B      2  8 4  7  7     28'
          i,←⊂' D      0  0 0 13  0     13'
          i,←⊂' A      0  5 0  5  6     16'
          i,←⊂' Total  9 32 7 47 13    108'
     
          i,←'' 'Average:' '   ]pivottable M -f=+/ ÷ ≢' '...'
     
          i,←'' '   ]pivottable "(5 2⍴''GrpA'' ''case1'' ''GrpB'' ''case1'' ''GrpB'' ''case2'' ''GrpA'' ''case1'' ''GrpB'' ''case2''),⍳5"  -f=+/'
          i,←⊂'        case1  case2  Total'
          i,←⊂' GrpA       5      0      5'
          i,←⊂' GrpB       2      8     10'
          i,←⊂' Total      7      8     15'
          r←⊃i
      :EndSelect
    ∇

⍝ Spice example:
⍝ fncalls  utils\callingTree ctor -details -treeview

    :SECTION Test
    ∇ r←Test dummy;T;cmd;n;ns;fn2;fn1;nl;t
      r←⍬ ⋄ T←{⎕SE.UCMD cmd,' ',⍵}
      fn1←{fn2 ⍵
   ⍝ Do something
      }
      fn2←*○
      'ns'⎕NS'fn1' 'fn2'
      :For cmd :In AllCmds
          :Trap n←0
              :Select cmd
              :Case 'Summary'
                  n←(T'ns')[;(⍳27)~14+⍳4]≡3 23⍴' name  scope    syntax  fn1             r2f    fn2             n0f   '
              :Case 'Calls'
                  n←(T'fn1')≡'Level 1:  →fn1',nl,'⍝ Do something',nl,'  F:fn2',(2/nl←⎕UCS 13),'Level 2: fn1→fn2'
              :Case 'Xref'
                  n←(T'ns')≡6 8⍴'       ⍵    fn2.      ↓↓[FNS]  -fn1   F○fn2    .'
              :Case 'CD'
                  n←(t≡(-⍴t)↑T'')∧(0⍴t←T'\tmp')≡'' ⋄ {}T t
              :Case 'Display'
                  n←(T'⎕NR ''fn2''')≡3 4⍴⎕UCS 9484 8594 9472 9488 9474 42 9675 9474 9492 9472 9472 9496
              :Case 'Disp'
                  n←(T'⎕NR ''fn1''')≡3 34⍴(⎕UCS 9484 8594,(10/9472),9516,(17/9472),9516 9472 9472 9488 9474),' fn1←{fn2 ⍵',(⎕UCS 9474),'   ⍝ Do something',(⎕UCS 9474 32 125 9474 9492,(10/9472),8594 9524,(16/9472),8594 9524 9472 8594 9496)
              :Case 'toHex'
                  n←(T'912559 49374')≡'DECAF' 'C0DE'
              :Case 'fromHex'
                  n←(T'BAD C0FFEE 0x1DE')≡2989 12648430 478
              :Case 'Factors'
                  n←(T'1066')≡2 13 41
              :Case 'toQuadTS' ⍝ Wrongly thinks 2100 is a leap year:
                  n←(T'246453E6')≡2100 2 29 2 6 40 0
              :Case 'PivotTable'
                  n←(T'2 3⍴⍳6 -f=+/')≡4 4⍴' ' 2 5 'Total' 1 3 0 3 4 0 6 6 'Total' 3 6 9
              :EndSelect
          :EndTrap
          r,←n
      :EndFor
     
    ∇
    :ENDSECTION

:Endnamespace ⍝ Summary  $Revision: 28192 $
