﻿:namespace system ⍝ V1.02
⍝ Show loaded assemblies in memory
⍝ 2015 05 22 Adam: NS header

    ⎕IO←1 ⋄ ⎕ML←1 ⋄ AllCmds←,⊂'Assemblies'  
    NOTWIN←'Windows'≢7↑1⊃'.'⎕WG'aplversion'

    ∇ r←List
      r←NOTWIN↓⎕NS¨0/¨AllCmds
      →NOTWIN/0
    ⍝ Name, group, short description and parsing rules
      r.Name←AllCmds
      r.Group←⊂'MSWIN'
      r[1].Desc←'show loaded assemblies in memory'
      r.Parse←⊂''
    ∇

    ∇ r←Run(Cmd Args);⎕USING
      :Select Cmd
      :Case 'Assemblies'
          r←'* No assemblies currently loaded'
          :Trap 90
              ⎕USING←'System'
              r←↑⍕¨AppDomain.CurrentDomain.GetAssemblies
          :EndTrap
      :EndSelect
    ∇

    ∇ r←l Help Cmd;⎕ML
      ⎕ML←1
      :Select Cmd
      :Case 'Assemblies'
          r←'Show all assemblies currently loaded into memory'
      :EndSelect
    ∇

:Endnamespace
 ⍝ system  $Revision: 26567 $ 