﻿:namespace tohtml ⍝ V1.01
⍝ Produce an HTML version of APL objects
⍝ 2015 05 22 Adam: NS header

    (⎕IO ⎕ML)←1 ⋄ AllCmds←,⊂'ToHTML'

    ∇ r←List
      r←⎕NS¨0/¨AllCmds
⍝ Name, group, short description and parsing rules
      r.Name←AllCmds
      r.Group←⊂'Array'
      r[1].Desc←'Produce an HTML version of APL objects'
      r.Parse←⊂' -title=  -full  -filename=  -clipboard  -xref '
    ∇

    ∇ r←Run(Cmd Args)
      0 ## ⎕SE.SALT.Load'tools\Inet\HTMLdoc'
      r←Args ##.HTMLdoc.PrepareCodeForHtml Args.Arguments
    ∇

    ∇ z←lev Help Cmd;⎕ML;r
      ⎕ML←1
      r←⍬
      r,←⊂'Prepare some HTML text to display functions and namespaces in a browser.'
      r,←⊂'The FULL switch includes header and css info.'
      r,←⊂'The FILENAME switch allows you to redirect output to a file.'
      r,←⊂'The CLIPBOARD switch redirects output to the clipboard.'
      r,←⊂'The XREF switch produces a cross reference of names for each function.'
      z←↑r
      →lev↓0
      r,←'' 'Example: produce an html file showing class Parser along with a cross reference'
      r,←'in file \tmp\x.html' '      ]tohtml ⎕se.Parser -file=\tmp\x.html -xref'
      z←↑r
    ∇

:Endnamespace ⍝ tohtml  $Revision: 25207 $ 