﻿:namespace update ⍝ V0.12
⍝ UUpdate script
⍝ 2015 05 22 Adam: NS header and auto Version
⍝ 2016 05 16 DanB: help text changed

    ∇ r←Version;⎕ML
      ⎕ML←1
      r←⊢/∊'V'⎕VFI⊃⎕SRC ⎕THIS
    ∇

    Cmds←,⊂ 'UUpdate'  ⋄ TOOLS←'SALT' 'UCMD' ⋄ NL←⎕ucs 10

    ⎕ML←1 ⋄ ⎕IO←1

    ∇ r←List
      r←⎕NS¨(⍴Cmds)⍴⊂''
      r.Name←Cmds
      r.(Group Parse)←⊂'UCMD' ''
      r[1].(Desc Parse)←'Update Tools with the latest version' ''
    ∇

    TOOLSaddr←'http://tools.dyalog.com/'  ⍝ change to HTTPS when ready

    ∇ r←Run(Cmd Args);t;upd;del;ec;⎕TRAP;msg;url
    ⍝ Cover for update procedure
      :If 0<⎕SE.SALTUtils.DEBUG
      :AndIf 9=#.⎕NC'update'
          upd←#.update ⍝ use ws version in debug mode
      :Else
          (↑'DRC' 'HTTPUtils')⎕CY'conga'
          (ec msg t)←3↑HTTPGet url←TOOLSaddr,'UCMDS/update.dyalog'
          ⎕TRAP←((700+⍳12)'N')(0 'C' '→ERR') ⍝ pass parsing error above
          :If (~0∊ec)∨1∊'404 not found'⍷⍕msg
              (ec msg t)←3↑HTTPGet'http',5↓url ⍝ try non-secure version if secured failed
              →(ec≠0)/ERR
          :EndIf
          del←⎕AV[4 3]∩t  ⍝ we cannot use ⎕UCS 13 in Classic Unix
          t←{1↓¨⍵⊂⍨⍵∊1↑⍵}(1↑del),t~1↓del
          upd←0 ⎕FIX t
      :EndIf
      :If ' '∊1↑0⍴Args ⍝ character argument?
          r←upd.Run(Cmd Args)
      :Else
          r←Args upd.Help(Cmd)
      :EndIf
      →0
     ERR:⎕TRAP←0⍴⎕TRAP
      r←'Update unavailable: ',(⎕IO+0=ec)⊃(msg)(⎕EM ⎕EN)
    ∇

    split←{(p↑⍵)((p←¯1+⍵⍳⍺)↓⍵)}

    BOM←239 187 191

    ∇ r←{certs}HTTPGet url;U;protocol;wr;key;flags;pars;secure;data;z;header;datalen;host;port;done;cmd;b;page;auth;p;x509;priority
⍝ Get an HTTP page, format [HTTP[S]://][user:pass@]url[:port][/page]
⍝ Opional Left argument: PublicCert PrivateKey SSLValidation
⍝ Makes secure connection if left arg provided or URL begins with https:
     
⍝ Result: (return code) (HTTP headers) (HTTP body) [PeerCert if secure]
     
      U←HTTPUtils ⍝ Uses utils from here
      {}DRC.Init''
     
      p←(∨/b)×1+(b←'//'⍷url)⍳1
      secure←(2=⎕NC'certs')∨(U.lc(p-2)↑url)≡'https:'
      port←(1+secure)⊃80 443 ⍝ Default HTTP/HTTPS port
      url←p↓url              ⍝ Remove HTTP[s]:// if present
      (host page)←'/'split url,(~'/'∊url)/'/'    ⍝ Extract host and page from url
     
      :If 0=⎕NC'certs' ⋄ certs←'' ⋄ :EndIf
     
      :If secure
          (x509 flags priority)←3↑certs,(⍴,certs)↓(⎕NEW DRC.X509Cert)32 'NORMAL:!CTYPE-OPENPGP'  ⍝ 32=Do not validate Certs
          pars←('x509'x509)('SSLValidation'flags)('Priority'priority)
      :Else ⋄ pars←''
      :EndIf
     
      :If '@'∊host ⍝ Handle user:password@host...
          auth←NL,'Authorization: Basic ',(U.Encode(¯1+p←host⍳'@')↑host)
          host←p↓host
      :Else ⋄ auth←''
      :EndIf
     
      (host port)←port U.HostPort host ⍝ Check for override of port number
     
      :If 0=⊃(r cmd)←2↑DRC.Clt''host port'Raw' 100000,pars ⍝ 100,000 is max receive buffer size
      :AndIf 0=⊃r←DRC.Send cmd(⎕UCS'GET ',page,' HTTP/1.1',NL,'Host: ',host,':',(⍕port),NL,'Accept: */*',auth,NL,NL)
     
          (done data)←header←0 ⍬
     
          :Repeat
              :If ~done←0≠1⊃wr←DRC.Wait cmd 5000            ⍝ Wait up to 5 secs
                  :If wr[3]∊'Block' 'BlockLast'             ⍝ If we have some data
                      :If 0<⍴data,←4⊃wr
                      :AndIf 0=1⊃header
                          b←¯1+1⍳⍨BOM⍷data
                          header←U.DecodeHeader ⎕UCS b↑data
                          :If 0<1⊃header
                              data←(1⊃header)↓data
                              datalen←⊃((2⊃header)U.GetValue'Content-Length' 'Numeric'),¯1 ⍝ ¯1 if no content length not specified
                          :EndIf
                      :EndIf
                  :Else
                      ('Unexpected error. Code = ',⍕wr)⎕SIGNAL ⎕SE.SALTUtils.DEBUG↓911
                      ÷'stopped for debugging'
                  :EndIf
     
                  done←'BlockLast'≡3⊃wr                        ⍝ Done if socket was closed
                  :If datalen>0
                      done←done∨datalen≤⍴data ⍝ ... or if declared amount of data rcvd
                  :Else
                      done←done∨(∨/'</html>'⍷data)∨(∨/'</HTML>'⍷data)
                  :EndIf
              :EndIf
          :Until done
     
          :Trap 0 ⍝ If any errors occur, abandon conversion
              b←BOM≡3↑data
              :If b∨∨/'charset=utf-8'⍷(2⊃header)U.GetValue'content-type' ''
                  data←'UTF-8'⎕UCS(3×b)↓data ⍝ Convert from UTF-8
              :Else
                  data←⎕UCS data
              :EndIf
          :EndTrap
     
          r←(1⊃wr)(2⊃header)data
          :If secure ⋄ r←r,⊂DRC.GetProp cmd'PeerCert' ⋄ :EndIf
      :Else
          r←r,⊂'Connection failed (',cmd,')'
      :EndIf
     
      z←DRC.Close cmd
      DRC.⎕EX¨DRC.⍙naedfns ⍝ we need to do this otherwise the connection stays opened
    ∇

    ∇ r←level Help Cmd
    ⍝ Default help
      r←⊂1⌽')Switches: -noprompt, max 1 argument (must be one of',⍕TOOLS
      r,←'' 'This command will update your current tools to the latest version.'
      r,←⊂'You need Internet access to perform an update.'
      r,←'' 'SALT and/or UCMDs will be updated for all instances of this version of Dyalog APL'
      r,←'on any operating system.' ''
     
      r,←⊂'It is possible a conflict with Conga exists when running this command in a workspace'
      r,←⊂'already using Conga actively. You should preferably run this command in a workspace'
      r,←⊂'not using it.'
      r←↑r
    ⍝ Try the server help
      :Trap 0
          r←Run Cmd level
      :EndTrap
    ∇

:Endnamespace ⍝ update  $Revision: 27420 $
