﻿:Namespace wsc ⍝ V1.13
⍝ Objects comparison utility made from ws 'compare' for V11
⍝ 2015 05 22 Adam: NS header and auto Version

⍝ Because there are many commands starting with 'compare' we do not use the cmd name but
⍝ the GROUP name for all Object Types (1-4)

    (⎕IO ⎕ML)←1

    ∇ r←Version;⎕ML
      ⎕ML←1
      r←⊢/∊'V'⎕VFI⊃⎕SRC ⎕THIS
    ∇

    AllCmds←4⍴⊂'Compare' ⍝ the same command name for all here - this is a special case
    lGroups←⎕se.Dyalog.Utils.lcase¨ Groups← 'WS' 'Array' 'FN' 'File'


    ∇ r←List;CompCode
      r←⎕NS¨(⍴AllCmds)⍴⊂⍬
     ⍝ Name, group, short description and parsing rules
      r.Name←AllCmds
      r.Group←Groups
      r.Desc←,∘' comparison'¨'workspaces' 'variables' 'functions' 'component files'
      CompCode←⎕SE.SALT.Load'spice/compare.code -nolink -noname'
      r.Parse←'1-2' '2' '2' '2',¨⍕¨CompCode.(Sets/¨⊂cSw)
    ∇

    ∇ r←Run(Cmd Args);CompCode
      CompCode←⎕SE.SALT.Load'spice/compare.code -nolink -noname'
      CompCode.ZONE←CompCode._ZONE Args.Switch'window'
      CompCode.SHOW←CompCode._SHOW Args.Switch'show'
      CompCode.NLINES←CompCode._NLINES Args.Switch'nlines'
      CompCode.DELINS←CompCode._DELINS Args.Switch'delins'
      CompCode.(NOLASTLINE NSSRC EXSTRING EXNAMES TRIM)←Args.Switch¨'nolastline' 'nssrc' 'exstring' 'exnames' 'normalize'
      CompCode.TS←Args.Switch'ts'
      CompCode.NAMECLASS←0 Args.Switch'nameclass'
     
      :Select lGroups⍳⊂##.Group
      :Case 1 ⍝ 'ws.compare'
          r←CompCode.compare Args
      :Case 3 ⍝ 'fns.compare'
          'Invalid function name'⎕SIGNAL 11↓⍨∧/(##.THIS.⎕NC↑Args.Arguments)∊3 4
          r←##.THIS CompCode.comp2fn Args
      :Case 2 ⍝ 'array.compare'
          'Invalid variable name'⎕SIGNAL 11↓⍨∧/(##.THIS.⎕NC↑Args.Arguments)∊2 9
          r←##.THIS CompCode.comp2var Args
      :Case 4 ⍝ 'file.compare'
          r←CompCode.compfiles Args
      :EndSelect
    ∇

    ∇ r←lev Help Cmd;⎕ML;i;obj;c;CR
      ⎕ML←1 ⋄ i←lGroups⍳⊂##.Group ⋄ CR←⎕AV[4] ⋄ c←⎕SE.SALT.Load'spice/compare.code -nolink -noname'
      r←lev c.Help i
     ⍝ r←1↓∊CR,¨(i⊃c.Sets,1)/c.SwitchesDefn
     ⍝ obj←i⊃'workspace' 'variable' 'function' 'file' 'object'
     ⍝ r←'Compare 2 ',obj,'s in details. Switches are:',CR,r
      :If i=1
          r,←CR,CR,'Example:',CR,'    ]ws.compare \qa\ws\testkeep =\testcompare'
      ⍝    r,←CR,CR,'If only one argument is given the current workspace on file is used for comparison,'
      ⍝    r,←CR,'NOT the current workspace in memory. To find out the name of the file ⎕WSID is used.'
      :AndIf lev>0
          r←CR,c.Describe
      :EndIf
    ∇

:EndNamespace ⍝ wsc  $Revision: 25207 $